<?php

namespace AutoOCR\HTTP;


class AutoOCRRESTClient {

    private $root_url = "";
    private $curr_url = "";
    private $user_name = "";
    private $password = "";
    private $response = "";
    private $responseBody = "";
    private $responseCookies = array();
    private $req = null;

    public function __construct($user_name="",$password="") {
    	if ($this->user_name != "" && $this->password != "") {
    		$this->user_name = $user_name;
    		$this->password = $password;	
    	}	
    }

    public function createRequest($url, $method, $arr = null, $arrFormat = null) {
        $this->curr_url = $url;

        $this->req = @new \HTTP_Request($this->curr_url);
        $this->req->_allowRedirects = true;

        if ($this->user_name != "" && $this->password != "") {
           $this->req->setBasicAuth($this->user_name, $this->password);
        }        
        
        switch($method) {
            case "GET":
                $this->req->setMethod(HTTP_REQUEST_METHOD_GET);
                break;
            case "POST":
                $this->req->setMethod(HTTP_REQUEST_METHOD_POST);
                if ($arrFormat == "json") {
                    $this->req->addHeader("Content-Type","application/json");
                    $this->req->addRawPostData($arr);

                }
                else
                    $this->addPostData($arr);
                break;
            case "PUT":
                $this->req->setMethod(HTTP_REQUEST_METHOD_PUT);
                if ($arrFormat == "json") {
                    $this->req->addHeader("Content-Type","application/json");
                    $this->req->addRawPostData($arr);
                }
                else {
                    if (is_array($arr)) {
                        $this->addPostData($arr);
                    }
                    else 
                        $this->req->addRawPostData($arr);
                }
                // to-do
                break;
            case "DELETE":
                $this->req->setMethod(HTTP_REQUEST_METHOD_DELETE);
                // to-do
                break;
        }
    }
    
    public function addPostFile($inputName, $fileName, $contentType = null) {
        $this->req->addFile($inputName, $fileName, $contentType);
    }

    private function addPostData($arr) {
        if ($arr != null) {
            foreach ($arr as $key => $value) {
                $this->req->addPostData($key, $value);
            }
        }
    }

    public function sendRequest() {
        $this->response = $this->req->sendRequest();

        if (\PEAR::isError($this->response)) {
            throw new \Exception($this->response->getMessage());
        } else {
        	$this->responseCookies = $this->req->getResponseCookies();
            $this->responseBody = $this->req->getResponseBody();

        }
    }
    
    public function addCookie($name,$value) {
    	$this->req->addCookie($name,$value);
    }
    
    public function getResponseCookies() {
    	return $this->responseCookies;
    }

    public function getResponse() {
        return $this->responseBody;
    }


}
?>